CIELRCPT - Editorial

PROBLEM LINK

Practice
Contest

DIFFICULTY

CAKEWALK

PREREQUISITES

Greedy Algorithms

PROBLEM

You need to find the representation of a given integer N as a sum of powers of two up to 211 with the smallest number of summands (repetitions in representation are allowed).

QUICK EXPLANATION

The problem can be solved by greedy algorithm: at each step we should take the largest possible menu that we can. To prove this noticed that if we order two equal menus, say 4 and 4, then we can order instead one menu of cost 8. In this problem you can implement this approach in any way you like but the easiest and fastest way gives the following pseudo-code:

res = 0
for i = 11 to 0
  res = res + N div 2i
  N = N mod 2i

EXPLANATION

At first we reveal the answer and then will prove it in detail. Write N as Q * 2048 + R, where Q and R are non-negative integers and R < 2048. Then the answer is Q + bitCount(R), where bitCount(X) is the number of ones in binary representation of X. If R = 2h[1] + 2h[2] + … + 2h[K] is a binary representation of R then the optimal representation of N is N = 2048 + … + 2048 + 2h[1] + 2h[2] + … + 2h[K] where we have Q copies of 2048. Let’s call this approach formula approach.

Another way to come up with this answer is to use Greedy Algorithm. That is, at each step you should take the largest possible summand among {1, 2, 4, 8, …, 2048} that is not greater than the current value of N and then subtract it from N. In fact, this problem is a special case of Change-making problem and in general it should be solved using Dynamic Programming or Integer Linear Programming but this set of coin values is special and admit using of Greedy Algorithm as we will see below.

Now we discuss why both of these approaches are correct.


#1. Formula Approach.

Let’s prove that formula approach is correct. Consider some representation of N as a sum of allowed powers of two. Let there is exactly C[K] occurrences of 2K in this representation. Then we have

N = C[0] * 1 + C[1] * 2 + C[2] * 4 + … + C[11] * 2048

Note that the total number of summands here is C[0] + C[1] + … + C[10] + C[11]. Assume that for some K < 11 we have C[K] >=2, that is, we have at least two copies of 2K in the representation of N. Since K < 11 then the price 2K+1 is allowed. Hence we can replace two copies of 2K by one copy of 2K+1 not changing the value of sum but decreasing total number of summands. Thus, for optimal representation we should have

**C[K] <= 1** for all **K < 11**.                         (1)

We will show that under the constraints (1) representation of N is uniquely determined. Of course this unique representation will be the optimal one.

At first note that

R = C[0] * 1 + C[1] * 2 + C[2] * 4 + … + C[10] * 1024 <= 1 + 2 + 4 + … + 1024 = 2047 < 2048.

Hence

2048 * C[11] <= N < 2048 * (C[11] + 1)

or

C[11] <= N / 2048 < C[11] + 1

which means by one of the definition of floor function that C[11] = floor(N / 2048) = Q. So C[11] is uniquely determined under the constraints (1) and equals to Q.

Further note that due to (1) C[10]C[9]…C[1]C[0] is a binary representation of R and hence C[0], C[1], …, C[10] are also uniquely determined under the constraints (1).

Thus we have found this unique representation.

Next we have bitCount(R) = C[0] + C[1] + … + C[10]. Hence the total number of summands in this representation is Q + bitCount(R) as was announced earlier. The complexity of this method is O(K), where K = 12 is the total number of powers of two that we are allowed to use.


#2. Greedy Approach.

Now let’s see why greedy approach produces the same solution. Clearly at first several steps we will take the 2048 until we get a number strictly less than 2048. Then we will consider powers of two in descending order starting from 1024 and take the current power of two if it is not greater than the current value of N. It is quite clear that this process generates exactly the binary representation of N. Thus the whole representation coincides with the constructed above.

There are several ways how to implement this algorithm in this problem. First one is simple but slower in general. Namely, we have an outer loop of the form while (N > 0). Then at each iteration of this loop we simply check in one loop all allowed powers of two in descending order until we find the power of two, say 2X, that is not greater than the current value of N. After that we decrease N by 2X and increase answer by 1. The complexity of this approach is O(N / 2K-1 + K2) in the worst test case. This is because at first N / 2K-1 steps we have only one iteration of inner loop (we break at 2048) and then we have at most K steps for each of which we have at most K steps in the inner loop.

In second method we swap outer and inner loop of the first method. So we iterate over allowed powers of two in descending order and for each power of two we have an inner loop of the form while (N >= 2X) in the body of which we do the same as for the first method, that is, decrease N by 2X and increase answer by 1. The complexity of this method is O(N / 2K-1 + K). Strictly speaking the number of basic operations in this method is O(answer + K). N / 2K-1 + K is an upper bound for the answer.

Analyzing second implementation of the greedy approach it is easy to see how to make it faster. For each power of two we have the following inner loop

while N >= 2X do
  N = N - 2X
  res = res + 1

Clearly this equivalent to

  res = res + N div 2X
  N = N mod 2X

Thus we obtain third implementation of the greedy algorithm with complexity O(K).


#3. Dynamic Programming Approach.

Now let’s consider another approach that allows to find the answer for arbitrary set of coin values in reasonable time. We will use dynamic programming. Let d1, …, dK be the set of allowed coin values (they all are positive). Denote by F(P) the minimal number of coins needed to represent P by this set of coins (repetitions in representation are allowed). Clearly F(0) = 0. Consider some value of P > 0. Then it is quite clear that

**F(P) = min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.**             (2)

where we set for convenience F(x) = INF for x < 0 (INF is some very large number). But let’s prove this formally.

At first consider the optimal representation for P. Let it be P = A1 + … + AL where L = F(P) and each Ai is of course equal to one of dj. Then A2 + … + AL is some representation of P – A1 of the length L – 1. By definition of F(P – A1) we have
L – 1 >= F(P – A1)
or
F(P) >= F(P – A1) + 1.
Since A1 is equal to one of dj then
F(P – A1) >= min{F(P - d1), F(P - d2), …, F(P - dK)}.
Combining the last two inequalities we get the first part of (1). Namely

**F(P) >= min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.**             (3)

Now let dj be those coin value for which F(P - dj) is minimal among F(P - d1), F(P - d2), …, F(P - dK). Let B1, …, BZ be the optimal representation for P - dj. That is P - dj = B1 + … + BZ and Z = F(P – dj). But then P = dj + B1 + … + BZ. So P has a representation of the length Z + 1 which by definition of F(P) means that

**F(P) <= Z + 1 = F(P – dj) + 1 = min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.**             (4)

Now (2) follows from (3) and (4). Formula (2) allows to find all values F(0), F(1), …, F(N) in a simple double loop. So F(N) can be found in O(N * K) time with O(N + K) memory.

SETTER’S SOLUTION

Can be found here.
Setter used the third implementation of the greedy approach described above.

TESTER’S SOLUTION

Can be found here.
Tester solution has complexity O(log N) (if we replace i <= 17 by 2i <= h). In this solution he implicitly deals with more natural version of the problem where all powers of two are allowed, that is, we simply need to find bitCount(h). To get the correct answer he increase answer by 2i-11 instead of 1 for each power of two that is greater than 211 and presented in the binary expansion of h.

RELATED PROBLEMS

Greedy Change (Codeforces Beta Round #10, problem E)
Let Me Count The Ways (UVA 357)

12 Likes

Can anyone tell me why this Python solution gets runtime error?
http://www.codechef.com/viewsolution/1187366

1 Like

hi @anton_lunyov…could you please explain the dynamic programming part more clearly …i dont understand how you got eqn (2) and also what Ai stands for and how L=F§…please explain the steps…thanks

4 Likes

note on my code: initialize the array of power 2, starting from 0 goes to 11. after getting p, starting from the maximum value of array(here 2048, index is arr[11]=2048) and check if p is equal to or greater than that value. if so, p=p-arr[i], count++. i also increased i++ so that continues from the index last visited. thnx

Convert into binary and count the number of one’s . That is the answer

4 Likes

#include<stdio.h>

int main()
{
short unsigned int t,i,n;
long unsigned int p;
scanf("%u",&t);
for(i=0;i<t;i++)
{
scanf("%ld",&p);
n = p/2048 + (p%2048)/1024 + ((p%2048)%1024)/512 + (((p%2048)%1024)%512)/256 + ((((p%2048)%1024)%512)%256)/128 + (((((p%2048)%1024)%512)%256)%128)/64 + ((((((p%2048)%1024)%512)%256)%128)%64)/32 + (((((((p%2048)%1024)%512)%256)%128)%64)%32)/16 + ((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)/8 + (((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)/4 + ((((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)%4)/2 + ((((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)%4)%2;
printf("%u\n",n);
}
return 0;
} 

runtime error… please help !!

1 Like

Write N as Q * 2048 + R, where Q and R are non-negative integers and R < 2048. Then the answer is Q + bitCount®, where bitCount(X) is the number of ones in binary representation of X.

This is my doubt as if N is less than 2048, we cant express the same as Q* 2048+ R as we are told that Q and R are integers( not a fraction ).

how to solve this problem in easy way please tell me…

can somebody please help me with my code here is the link : NovXIt - Online C++ Compiler & Debugging Tool - Ideone.com

i am getting wrong answer .

Why Isn’t THis Approach Working ??

    #include <iostream>
#include <cmath>
using namespace std;
typedef long long int ll;
int main() {
	ll t;
	cin>>t;
	while(t--)
	{
	    ll ans=0,p,lpow;
	    cin>>p;
	    while(p>0)
	    {
	        
	        lpow = log2(p);
	        
	        p-=pow(2,lpow);
	        ans++;
	       
	    }
	    cout<<ans<<endl;
	}
	return 0;
}

Hi,

i have tried to solve using recursion

code follows,but not being accepted as solution

please help,thanks

int n,p,divi,rem,t;

int calc(int num){

if (num == 0)
	return 0;

divi = num / 2048;

rem = num % 2048;

if (divi > 0)
	t = divi + calc(rem);
else
	t = calc(2 * rem);

return t;

}

int main(){

scanf("%d", &n);

for (int i = 0; i < n; i++){
	scanf("%d", &p);
	printf("%d \n", calc(p));
}

return 0;

}

#include<stdio.h>
int main()
{
int t,p,count,key;
scanf("%d",&t);
while(t–)
{
scanf("%d",&p);
if((p%2048)==0)
{
count=p/2048;
printf("%d",count);
printf("\n");
}
else
{
count=count_1§;
if(p/2048>1)
{
key=p/2048;
count=count+(key-1);
printf("%d",count);
printf("\n");
}
else
{
printf("%d",count);
printf("\n");
}
}
}
return 0;
}
int count_1(int n)
{
int ctd;
while(n)
{
n=n&(n-1);
ctd++;
}
return ctd;
}
it satisfy every case but during submission wrong answer

easiest way to solve the problem

import java.util.*;

import java.lang.*;

import java.io.*;

class Codechef
{
public static void main (String[] args) throws java.lang.Exception
{

	Scanner obj = new Scanner(System.in);
	int a[] = new int[12];
	
	for(int i=0;i<=11;i++){
	    a[i] = (int) Math.pow(2,i);
	}
	
	int n = obj.nextInt();
                          
	for(int i=1;i<=n;i++){
                
	    int p = obj.nextInt();
               
	    int k=0,l=0;                
                
	    while(a[k]<=p){
	        l=k;
	        k++;  
                    if(k==12){
                    break;}
	    } 
             
                
	    int count=0;
	    while(a[l]>=1){
	        
	        count= count+(p/a[l]);
                    p=p%a[l];
	        l=l-1;
                    if(l<0){
                    break;}
                    
	    }
	    
	   System.out.println(count);
	 }		
	    
	
}

}

i need to convert the set of number into “k”, “mil”, “bil” for my php website (Soundcloud downloader) when i implement this code the website automatically turns into error 500. Expert advice needed

I found one of the best solution for it, ie: convert decimal to binary and count the number of ones in it. that’s the answer.

for eg:

decimal: 253

binary: 11111101

no of ones: 7 that’s the answer.

For No > 2048, you have to use rest logic.

Thnx.

1 Like

Hey i tried the code using DP but the solution is not being accepted ,
the code works for the sample test cases and any other test case that i can think of .
Please help
Here is the link to my code :
https://www.codechef.com/viewsolution/14492082

can any one please check my code .I don’t know what is wrong it passed all sample tests.
https://www.codechef.com/viewsolution/17515413

Hello, guys, I have a website for downloading music from SoundCloud.
http://soundcloudmp3downloader.com/

And I hope u could help me… how can I get the information about bitrate of SC tracks?
is it possible? any idea?

My solution is a bit different and is very short if you are using C++ and stl as your tool to solve the problem
It uses a greedy approach to find the nearest value just smaller than or equal to n from the menu list.

    while (n > 0) {
        long nearest = upper_bound(menuList.begin(), menuList.end(), n) - menuList.begin();
        n -= menuList[nearest - 1];
        ++count;
    }

Here menuList is an array of the powers of 2 up to the required item - [1,2,4,8…]

int price[12] = {1, 2, 4, 8, 16, 32,
64, 128, 256, 512, 1024, 2048};

int t, p, c;
cin >> t;

for (int k = 0; k < t; k++)
{
    c = 0;
    cin >> p;
    while(p != 0) 
    {
        for (int i = 11; i >= 0; i--)
        {
            if (p >= price[i])
            {
                p -= price[i];
                c++;
                break;
            }
        }
    }
    cout << c << endl;
}
1 Like